--[[
        kl_asshole.lua
        
        
        This simple little script lets you be more of an asshole.
        Whenever you collide with (bump) another player, your mobj will remember the last player you touched. If that player
        gets killed, spun out, or squished (within a few seconds), your character will taunt with your HitEm sound.
        
        
        by Namolos
        Feel free to borrow from this if you wish
]]--

freeslot("sfx_goteem")

-- Handle flagging players when they collide
addHook("MobjThinker", function(mobj)
    -- init the table, because lazy way to get rid of errors
    if (mobj.asshole == nil)
        mobj.asshole = {
            lastPlayerBumped = nil,
            punishTimer = 0,
            deathTimer = 0,
            spamCooldown = 0
        }
    end
    
    -- timers
    if (mobj.asshole.punishTimer > 0)
        mobj.asshole.punishTimer = $-1
    end
    if (mobj.asshole.deathTimer > 0)
        mobj.asshole.deathTimer = $-1
    end
    if (mobj.asshole.spamCooldown > 0)
        mobj.asshole.spamCooldown = $-1
    end
    
    -- lazy man nil check
    if (mobj.asshole.lastPlayerBumped == nil)
        return
    end

    -- Did you get that person? Play the taunt or HitEm sound if you did
    if ( (mobj.asshole.punishTimer > 0)
     and (mobj.asshole.lastPlayerBumped.kartstuff[k_spinouttimer])           -- any spinout, really
     or  (mobj.asshole.lastPlayerBumped.kartstuff[k_squishedtimer]) )        -- flattened (this has the unintended side effect of you gloating when flattening people... which I'm not fixing because I think it's great)
    or ( (mobj.asshole.deathTimer > 0)
     and (mobj.asshole.lastPlayerBumped.playerstate == PST_DEAD) )           -- YOU KILLED THEM! HAHAHAHA
        mobj.asshole.punishTimer = 0
        mobj.asshole.deathTimer = 0
        if (mobj.asshole.spamCooldown == 0)                                  -- For some reason, k_voices and k_tauntvoices aren't working as I'd expect for this
            local gotem = P_RandomKey(128)                                   -- Obligatory chance for meme shit
            if (gotem == 0)
                S_StartSound(mobj, sfx_goteem)                               -- GOTEEM
            else
                if not (S_SoundPlaying(mobj, skins[mobj.skin].soundsid[SKSKHITM])) -- no double sound off if you knock someone into your own trap
                    if ( AH_customTauntTable and (AH_customTauntTable[mobj.skin] ~= nil) )
                        S_StartSound(mobj, AH_customTauntTable[mobj.skin])         -- custom taunt sound! Should be fun :P
                    else
                        K_PlayHitEmSound(mobj)                                     -- HitEm sound is used by default
                    end
                end
            end
            mobj.asshole.spamCooldown = TICRATE
        end
    end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(mobj, t)
    if (t.player and t.player.powers[pw_flashing] == 0)  -- No need to be a mondo asshole. If they're already suffering, don't gloat at them
        mobj.asshole.lastPlayerBumped = t.player
        mobj.asshole.deathTimer = 4*TICRATE              -- Honestly I'd make this shorter if not for tracks like Blue Mountain
        if (t.player.kartstuff[k_spinouttimer] == 0)     -- Don't set this timer if they're already spunout. Don't rub salt in the wound
            mobj.asshole.punishTimer = TICRATE + TICRATE/3
        end
    end
end, MT_PLAYER)
